"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertBytesTypeNode = exports.isBytesTypeNode = exports.displayBytesTypeNode = exports.bytesTypeNode = void 0;
const SizeStrategy_1 = require("../shared/SizeStrategy");
function bytesTypeNode(size) {
    return {
        kind: 'bytesTypeNode',
        size: size !== null && size !== void 0 ? size : (0, SizeStrategy_1.remainderSize)(),
    };
}
exports.bytesTypeNode = bytesTypeNode;
function displayBytesTypeNode(node) {
    return `bytes(${(0, SizeStrategy_1.displaySizeStrategy)(node.size)})`;
}
exports.displayBytesTypeNode = displayBytesTypeNode;
function isBytesTypeNode(node) {
    return !!node && node.kind === 'bytesTypeNode';
}
exports.isBytesTypeNode = isBytesTypeNode;
function assertBytesTypeNode(node) {
    var _a;
    if (!isBytesTypeNode(node)) {
        throw new Error(`Expected bytesTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertBytesTypeNode = assertBytesTypeNode;
//# sourceMappingURL=BytesTypeNode.js.map