"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertEnumEmptyVariantTypeNode = exports.isEnumEmptyVariantTypeNode = exports.enumEmptyVariantTypeNodeFromIdl = exports.enumEmptyVariantTypeNode = void 0;
const shared_1 = require("../shared");
function enumEmptyVariantTypeNode(name) {
    if (!name) {
        throw new shared_1.InvalidKinobiTreeError('EnumEmptyVariantTypeNode must have a name.');
    }
    return {
        kind: 'enumEmptyVariantTypeNode',
        name: (0, shared_1.mainCase)(name),
    };
}
exports.enumEmptyVariantTypeNode = enumEmptyVariantTypeNode;
function enumEmptyVariantTypeNodeFromIdl(idl) {
    var _a;
    return enumEmptyVariantTypeNode((_a = idl.name) !== null && _a !== void 0 ? _a : '');
}
exports.enumEmptyVariantTypeNodeFromIdl = enumEmptyVariantTypeNodeFromIdl;
function isEnumEmptyVariantTypeNode(node) {
    return !!node && node.kind === 'enumEmptyVariantTypeNode';
}
exports.isEnumEmptyVariantTypeNode = isEnumEmptyVariantTypeNode;
function assertEnumEmptyVariantTypeNode(node) {
    var _a;
    if (!isEnumEmptyVariantTypeNode(node)) {
        throw new Error(`Expected enumEmptyVariantTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertEnumEmptyVariantTypeNode = assertEnumEmptyVariantTypeNode;
//# sourceMappingURL=EnumEmptyVariantTypeNode.js.map