"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertNumberTypeNode = exports.isNumberTypeNode = exports.displayNumberTypeNode = exports.isDecimal = exports.isInteger = exports.isUnsignedInteger = exports.isSignedInteger = exports.numberTypeNode = void 0;
function numberTypeNode(format, endian = 'le') {
    return { kind: 'numberTypeNode', format, endian };
}
exports.numberTypeNode = numberTypeNode;
function isSignedInteger(node) {
    return node.format.startsWith('i');
}
exports.isSignedInteger = isSignedInteger;
function isUnsignedInteger(node) {
    return node.format.startsWith('u');
}
exports.isUnsignedInteger = isUnsignedInteger;
function isInteger(node) {
    return !node.format.startsWith('f');
}
exports.isInteger = isInteger;
function isDecimal(node) {
    return node.format.startsWith('f');
}
exports.isDecimal = isDecimal;
function displayNumberTypeNode(node) {
    return `${node.format}(${node.endian})`;
}
exports.displayNumberTypeNode = displayNumberTypeNode;
function isNumberTypeNode(node) {
    return !!node && node.kind === 'numberTypeNode';
}
exports.isNumberTypeNode = isNumberTypeNode;
function assertNumberTypeNode(node) {
    var _a;
    if (!isNumberTypeNode(node)) {
        throw new Error(`Expected numberTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertNumberTypeNode = assertNumberTypeNode;
//# sourceMappingURL=NumberTypeNode.js.map