"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringSeed = exports.publicKeySeed = exports.variableSeed = exports.stringConstantSeed = exports.constantSeed = exports.programSeed = void 0;
const nodes_1 = require("../nodes");
const SizeStrategy_1 = require("./SizeStrategy");
const utils_1 = require("./utils");
const programSeed = () => ({ kind: 'programId' });
exports.programSeed = programSeed;
const constantSeed = (type, value) => ({ kind: 'constant', type, value });
exports.constantSeed = constantSeed;
const stringConstantSeed = (value) => (0, exports.constantSeed)((0, nodes_1.stringTypeNode)({ size: (0, SizeStrategy_1.remainderSize)() }), (0, nodes_1.vScalar)(value));
exports.stringConstantSeed = stringConstantSeed;
const variableSeed = (name, type, docs = []) => ({
    kind: 'variable',
    name: (0, utils_1.mainCase)(name),
    type,
    docs: Array.isArray(docs) ? docs : [docs],
});
exports.variableSeed = variableSeed;
const publicKeySeed = (name, docs = []) => (0, exports.variableSeed)(name, (0, nodes_1.publicKeyTypeNode)(), docs);
exports.publicKeySeed = publicKeySeed;
const stringSeed = (name, docs = []) => (0, exports.variableSeed)(name, (0, nodes_1.stringTypeNode)({ size: (0, SizeStrategy_1.remainderSize)() }), docs);
exports.stringSeed = stringSeed;
//# sourceMappingURL=AccountSeed.js.map