"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseDelegateVisitor = void 0;
const Visitor_1 = require("./Visitor");
class BaseDelegateVisitor {
    constructor(visitor) {
        this.visitor = visitor;
    }
    visitRoot(root) {
        return this.map((0, Visitor_1.visit)(root, this.visitor));
    }
    visitProgram(program) {
        return this.map((0, Visitor_1.visit)(program, this.visitor));
    }
    visitAccount(account) {
        return this.map((0, Visitor_1.visit)(account, this.visitor));
    }
    visitAccountData(accountData) {
        return this.map((0, Visitor_1.visit)(accountData, this.visitor));
    }
    visitInstruction(instruction) {
        return this.map((0, Visitor_1.visit)(instruction, this.visitor));
    }
    visitInstructionAccount(instructionAccount) {
        return this.map((0, Visitor_1.visit)(instructionAccount, this.visitor));
    }
    visitInstructionDataArgs(instructionDataArgs) {
        return this.map((0, Visitor_1.visit)(instructionDataArgs, this.visitor));
    }
    visitInstructionExtraArgs(instructionExtraArgs) {
        return this.map((0, Visitor_1.visit)(instructionExtraArgs, this.visitor));
    }
    visitDefinedType(definedType) {
        return this.map((0, Visitor_1.visit)(definedType, this.visitor));
    }
    visitError(error) {
        return this.map((0, Visitor_1.visit)(error, this.visitor));
    }
    visitArrayType(arrayType) {
        return this.map((0, Visitor_1.visit)(arrayType, this.visitor));
    }
    visitLinkType(linkType) {
        return this.map((0, Visitor_1.visit)(linkType, this.visitor));
    }
    visitEnumType(enumType) {
        return this.map((0, Visitor_1.visit)(enumType, this.visitor));
    }
    visitEnumEmptyVariantType(enumEmptyVariantType) {
        return this.map((0, Visitor_1.visit)(enumEmptyVariantType, this.visitor));
    }
    visitEnumStructVariantType(enumStructVariantType) {
        return this.map((0, Visitor_1.visit)(enumStructVariantType, this.visitor));
    }
    visitEnumTupleVariantType(enumTupleVariantType) {
        return this.map((0, Visitor_1.visit)(enumTupleVariantType, this.visitor));
    }
    visitMapType(mapType) {
        return this.map((0, Visitor_1.visit)(mapType, this.visitor));
    }
    visitOptionType(optionType) {
        return this.map((0, Visitor_1.visit)(optionType, this.visitor));
    }
    visitSetType(setType) {
        return this.map((0, Visitor_1.visit)(setType, this.visitor));
    }
    visitStructType(structType) {
        return this.map((0, Visitor_1.visit)(structType, this.visitor));
    }
    visitStructFieldType(structFieldType) {
        return this.map((0, Visitor_1.visit)(structFieldType, this.visitor));
    }
    visitTupleType(tupleType) {
        return this.map((0, Visitor_1.visit)(tupleType, this.visitor));
    }
    visitBoolType(boolType) {
        return this.map((0, Visitor_1.visit)(boolType, this.visitor));
    }
    visitBytesType(bytesType) {
        return this.map((0, Visitor_1.visit)(bytesType, this.visitor));
    }
    visitNumberType(numberType) {
        return this.map((0, Visitor_1.visit)(numberType, this.visitor));
    }
    visitNumberWrapperType(numberWrapperType) {
        return this.map((0, Visitor_1.visit)(numberWrapperType, this.visitor));
    }
    visitPublicKeyType(publicKeyType) {
        return this.map((0, Visitor_1.visit)(publicKeyType, this.visitor));
    }
    visitStringType(stringType) {
        return this.map((0, Visitor_1.visit)(stringType, this.visitor));
    }
}
exports.BaseDelegateVisitor = BaseDelegateVisitor;
//# sourceMappingURL=BaseDelegateVisitor.js.map