"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseThrowVisitor = void 0;
const shared_1 = require("../shared");
class BaseThrowVisitor {
    visitRoot(root) {
        throw new shared_1.KinobiError('This visitor does not support Root nodes.');
    }
    visitProgram(program) {
        throw new shared_1.KinobiError('This visitor does not support Program nodes.');
    }
    visitAccount(account) {
        throw new shared_1.KinobiError('This visitor does not support Account nodes.');
    }
    visitAccountData(accountData) {
        throw new shared_1.KinobiError('This visitor does not support AccountDataNode nodes.');
    }
    visitInstruction(instruction) {
        throw new shared_1.KinobiError('This visitor does not support Instruction nodes.');
    }
    visitInstructionAccount(instructionAccount) {
        throw new shared_1.KinobiError('This visitor does not support InstructionAccountNode nodes.');
    }
    visitInstructionDataArgs(instructionDataArgs) {
        throw new shared_1.KinobiError('This visitor does not support InstructionDataArgsNode nodes.');
    }
    visitInstructionExtraArgs(instructionExtraArgs) {
        throw new shared_1.KinobiError('This visitor does not support InstructionExtraArgsNode nodes.');
    }
    visitDefinedType(definedType) {
        throw new shared_1.KinobiError('This visitor does not support DefinedType nodes.');
    }
    visitError(error) {
        throw new shared_1.KinobiError('This visitor does not support Error nodes.');
    }
    visitArrayType(arrayType) {
        throw new shared_1.KinobiError('This visitor does not support TypeArray nodes.');
    }
    visitLinkType(linkType) {
        throw new shared_1.KinobiError('This visitor does not support TypeDefinedLink nodes.');
    }
    visitEnumType(enumType) {
        throw new shared_1.KinobiError('This visitor does not support TypeEnum nodes.');
    }
    visitEnumEmptyVariantType(enumEmptyVariantType) {
        throw new shared_1.KinobiError('This visitor does not support TypeEnumEmptyVariant nodes.');
    }
    visitEnumStructVariantType(enumStructVariantType) {
        throw new shared_1.KinobiError('This visitor does not support TypeEnumStructVariant nodes.');
    }
    visitEnumTupleVariantType(enumTupleVariantType) {
        throw new shared_1.KinobiError('This visitor does not support TypeEnumTupleVariant nodes.');
    }
    visitMapType(mapType) {
        throw new shared_1.KinobiError('This visitor does not support TypeMap nodes.');
    }
    visitOptionType(optionType) {
        throw new shared_1.KinobiError('This visitor does not support TypeOption nodes.');
    }
    visitSetType(setType) {
        throw new shared_1.KinobiError('This visitor does not support TypeSet nodes.');
    }
    visitStructType(structType) {
        throw new shared_1.KinobiError('This visitor does not support TypeStruct nodes.');
    }
    visitStructFieldType(structFieldType) {
        throw new shared_1.KinobiError('This visitor does not support TypeStructField nodes.');
    }
    visitTupleType(tupleType) {
        throw new shared_1.KinobiError('This visitor does not support TypeTuple nodes.');
    }
    visitBoolType(boolType) {
        throw new shared_1.KinobiError('This visitor does not support TypeBool nodes.');
    }
    visitBytesType(bytesType) {
        throw new shared_1.KinobiError('This visitor does not support TypeBytes nodes.');
    }
    visitNumberType(numberType) {
        throw new shared_1.KinobiError('This visitor does not support TypeNumber nodes.');
    }
    visitNumberWrapperType(numberWrapperType) {
        throw new shared_1.KinobiError('This visitor does not support TypeNumberWrapper nodes.');
    }
    visitPublicKeyType(publicKeyType) {
        throw new shared_1.KinobiError('This visitor does not support TypePublicKey nodes.');
    }
    visitStringType(stringType) {
        throw new shared_1.KinobiError('This visitor does not support TypeString nodes.');
    }
}
exports.BaseThrowVisitor = BaseThrowVisitor;
//# sourceMappingURL=BaseThrowVisitor.js.map