"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultVisitor = void 0;
const nodes = __importStar(require("../nodes"));
const BaseThrowVisitor_1 = require("./BaseThrowVisitor");
const transformers_1 = require("./transformers");
const Visitor_1 = require("./Visitor");
class DefaultVisitor extends BaseThrowVisitor_1.BaseThrowVisitor {
    visitRoot(currentRoot) {
        let root = currentRoot;
        const updateRoot = (visitor) => {
            const newRoot = (0, Visitor_1.visit)(root, visitor);
            nodes.assertRootNode(newRoot);
            root = newRoot;
        };
        // Defined types.
        updateRoot(new transformers_1.DeduplicateIdenticalDefinedTypesVisitor());
        // Accounts.
        updateRoot(new transformers_1.AutoSetAnchorDiscriminatorsVisitor());
        updateRoot(new transformers_1.AutoSetFixedAccountSizesVisitor());
        // Instructions.
        updateRoot(new transformers_1.SetInstructionAccountDefaultValuesVisitor(transformers_1.DEFAULT_INSTRUCTION_ACCOUNT_DEFAULT_RULES));
        updateRoot(new transformers_1.UnwrapInstructionArgsDefinedTypesVisitor());
        updateRoot(new transformers_1.FlattenInstructionArgsStructVisitor());
        // Extras.
        updateRoot(new transformers_1.TransformU8ArraysToBytesVisitor());
        return root;
    }
}
exports.DefaultVisitor = DefaultVisitor;
//# sourceMappingURL=DefaultVisitor.js.map