"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetInstructionAccountDefaultValuesVisitor = exports.DEFAULT_INSTRUCTION_ACCOUNT_DEFAULT_RULES = void 0;
const nodes = __importStar(require("../../nodes"));
const shared_1 = require("../../shared");
const BaseNodeVisitor_1 = require("../BaseNodeVisitor");
const Visitor_1 = require("../Visitor");
exports.DEFAULT_INSTRUCTION_ACCOUNT_DEFAULT_RULES = [
    {
        kind: 'payer',
        account: /^payer|feePayer$/,
        ignoreIfOptional: true,
    },
    {
        kind: 'identity',
        account: /^authority$/,
        ignoreIfOptional: true,
    },
    {
        kind: 'programId',
        account: /^programId$/,
        ignoreIfOptional: true,
    },
    {
        kind: 'program',
        account: /^systemProgram|splSystemProgram$/,
        program: {
            name: 'splSystem',
            publicKey: '11111111111111111111111111111111',
        },
        ignoreIfOptional: true,
    },
    {
        kind: 'program',
        account: /^tokenProgram|splTokenProgram$/,
        program: {
            name: 'splToken',
            publicKey: 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA',
        },
        ignoreIfOptional: true,
    },
    {
        kind: 'program',
        account: /^ataProgram|splAtaProgram$/,
        program: {
            name: 'splAssociatedToken',
            publicKey: 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL',
        },
        ignoreIfOptional: true,
    },
    {
        kind: 'program',
        account: /^tokenMetadataProgram|mplTokenMetadataProgram$/,
        program: {
            name: 'mplTokenMetadata',
            publicKey: 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s',
        },
        ignoreIfOptional: true,
    },
    {
        kind: 'program',
        account: /^(tokenAuth|mplTokenAuth|authorization|mplAuthorization|auth|mplAuth)RulesProgram$/,
        program: {
            name: 'mplTokenAuthRules',
            publicKey: 'auth9SigNpDKz4sJJ1DfCTuZrZNSAgh9sFD3rboVmgg',
        },
        ignoreIfOptional: true,
    },
    {
        kind: 'program',
        account: /^candyMachineProgram|mplCandyMachineProgram$/,
        program: {
            name: 'mplCandyMachine',
            publicKey: 'CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR',
        },
        ignoreIfOptional: true,
    },
    {
        kind: 'program',
        account: /^candyGuardProgram|mplCandyGuardProgram$/,
        program: {
            name: 'mplCandyGuard',
            publicKey: 'Guard1JwRhJkVH6XZhzoYxeBVQe872VH6QggF4BWmS9g',
        },
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^clockSysvar|sysvarClockSysvar$/,
        publicKey: 'SysvarC1ock11111111111111111111111111111111',
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^epochScheduleSysvar|sysvarEpochSchedule$/,
        publicKey: 'SysvarEpochSchedu1e111111111111111111111111',
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^(instructions?Sysvar|sysvarInstructions?)(Account)?$/,
        publicKey: 'Sysvar1nstructions1111111111111111111111111',
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^recentBlockhashesSysvar|sysvarRecentBlockhashes$/,
        publicKey: 'SysvarRecentB1ockHashes11111111111111111111',
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^rent|rentSysvar|sysvarRent$/,
        publicKey: 'SysvarRent111111111111111111111111111111111',
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^rewardsSysvar|sysvarRewards$/,
        publicKey: 'SysvarRewards111111111111111111111111111111',
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^slotHashesSysvar|sysvarSlotHashes$/,
        publicKey: 'SysvarS1otHashes111111111111111111111111111',
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^slotHistorySysvar|sysvarSlotHistory$/,
        publicKey: 'SysvarS1otHistory11111111111111111111111111',
        ignoreIfOptional: true,
    },
    {
        kind: 'publicKey',
        account: /^stakeHistorySysvar|sysvarStakeHistory$/,
        publicKey: 'SysvarStakeHistory1111111111111111111111111',
        ignoreIfOptional: true,
    },
];
class SetInstructionAccountDefaultValuesVisitor extends BaseNodeVisitor_1.BaseNodeVisitor {
    constructor(rules) {
        super();
        this.allAccounts = new Map();
        // Place the rules with instructions first.
        this.rules = rules.sort((a, b) => {
            const ia = 'instruction' in a;
            const ib = 'instruction' in b;
            if ((ia && ib) || (!a && !ib))
                return 0;
            return ia ? -1 : 1;
        });
    }
    visitRoot(root) {
        nodes.getAllAccounts(root).forEach((account) => {
            this.allAccounts.set(account.name, account);
        });
        return super.visitRoot(root);
    }
    visitProgram(program) {
        return nodes.programNode({
            ...program,
            instructions: program.instructions
                .map((instruction) => (0, Visitor_1.visit)(instruction, this))
                .filter(nodes.assertNodeFilter(nodes.assertInstructionNode)),
        });
    }
    visitInstruction(instruction) {
        const instructionAccounts = instruction.accounts.map((account) => {
            var _a;
            const rule = this.matchRule(instruction, account);
            if (!rule) {
                return account;
            }
            if (((_a = rule.ignoreIfOptional) !== null && _a !== void 0 ? _a : false) && account.isOptional) {
                return account;
            }
            if (rule.kind === 'pda') {
                const foundAccount = this.allAccounts.get((0, shared_1.mainCase)(rule.pdaAccount));
                const defaultsTo = {
                    ...rule,
                    seeds: {
                        ...(foundAccount ? (0, shared_1.getDefaultSeedsFromAccount)(foundAccount) : {}),
                        ...rule.seeds,
                    },
                };
                if (rule.instruction) {
                    return { ...account, defaultsTo };
                }
                const allSeedsAreValid = Object.entries(defaultsTo.seeds).every(([, seed]) => {
                    if (seed.kind === 'value')
                        return true;
                    if (seed.kind === 'account') {
                        return instruction.accounts.some((a) => a.name === (0, shared_1.mainCase)(seed.name));
                    }
                    if (instruction.dataArgs.link)
                        return true;
                    return instruction.dataArgs.struct.fields.some((f) => f.name === (0, shared_1.mainCase)(seed.name));
                });
                if (allSeedsAreValid) {
                    return { ...account, defaultsTo };
                }
                return account;
            }
            return { ...account, defaultsTo: rule };
        });
        return nodes.instructionNode({
            ...instruction,
            accounts: instructionAccounts,
        });
    }
    matchRule(instruction, account) {
        return this.rules.find((rule) => {
            if ('instruction' in rule &&
                rule.instruction &&
                (0, shared_1.mainCase)(rule.instruction) !== instruction.name) {
                return false;
            }
            return typeof rule.account === 'string'
                ? (0, shared_1.mainCase)(rule.account) === account.name
                : rule.account.test(account.name);
        });
    }
}
exports.SetInstructionAccountDefaultValuesVisitor = SetInstructionAccountDefaultValuesVisitor;
//# sourceMappingURL=SetInstructionAccountDefaultValuesVisitor.js.map