"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformDefinedTypesIntoAccountsVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const BaseNodeVisitor_1 = require("../BaseNodeVisitor");
class TransformDefinedTypesIntoAccountsVisitor extends BaseNodeVisitor_1.BaseNodeVisitor {
    constructor(definedTypes) {
        super();
        this.definedTypes = definedTypes;
    }
    visitProgram(program) {
        const typesToExtract = program.definedTypes.filter((node) => this.definedTypes.includes(node.name));
        const newDefinedTypes = program.definedTypes.filter((node) => !this.definedTypes.includes(node.name));
        const newAccounts = typesToExtract.map((node) => {
            nodes.assertStructTypeNode(node.data);
            return nodes.accountNode({
                ...node,
                data: nodes.accountDataNode({
                    name: `${node.name}AccountData`,
                    struct: node.data,
                }),
                size: undefined,
                discriminator: undefined,
                seeds: [],
            });
        });
        return nodes.programNode({
            ...program,
            accounts: [...program.accounts, ...newAccounts],
            definedTypes: newDefinedTypes,
        });
    }
}
exports.TransformDefinedTypesIntoAccountsVisitor = TransformDefinedTypesIntoAccountsVisitor;
//# sourceMappingURL=TransformDefinedTypesIntoAccountsVisitor.js.map