"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateAccountsVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const shared_1 = require("../../shared");
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
const _renameHelpers_1 = require("./_renameHelpers");
class UpdateAccountsVisitor extends TransformNodesVisitor_1.TransformNodesVisitor {
    constructor(map) {
        const transforms = Object.entries(map).map(([selector, updates]) => {
            const selectorStack = selector.split('.');
            const name = selectorStack.pop();
            return {
                selector: { kind: 'accountNode', stack: selectorStack, name },
                transformer: (node, stack, program) => {
                    var _a, _b;
                    nodes.assertAccountNode(node);
                    if (typeof updates === 'function') {
                        return updates(node, stack, program);
                    }
                    if ('delete' in updates) {
                        return null;
                    }
                    const newName = (0, shared_1.mainCase)((_a = updates.name) !== null && _a !== void 0 ? _a : node.name);
                    return nodes.accountNode({
                        ...node,
                        ...updates,
                        data: nodes.accountDataNode({
                            ...node.data,
                            name: `${newName}AccountData`,
                            struct: (0, _renameHelpers_1.renameStructNode)(node.data.struct, (_b = updates.data) !== null && _b !== void 0 ? _b : {}),
                        }),
                    });
                },
            };
        });
        super(transforms);
        this.map = map;
    }
}
exports.UpdateAccountsVisitor = UpdateAccountsVisitor;
//# sourceMappingURL=UpdateAccountsVisitor.js.map