import { IdlInputs, Node, RootNode } from './nodes';
import { Visitor } from './visitors';
export interface Kinobi {
    getRoot(): RootNode;
    getJson(): string;
    accept<T>(visitor: Visitor<T>): T;
    update(visitor: Visitor<Node | null>): void;
    clone(): Kinobi;
}
export declare function createFromRoot(root: RootNode, useDefaultVisitor?: boolean): Kinobi;
export declare function createFromIdls(idls: IdlInputs, useDefaultVisitor?: boolean): Kinobi;
export declare function createFromJson(json: string, useDefaultVisitor?: boolean): Kinobi;
