import type { IdlTypeMap } from '../idl';
import { SizeStrategy } from '../shared';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
export type MapTypeNode = {
    readonly __mapTypeNode: unique symbol;
    readonly kind: 'mapTypeNode';
    readonly key: TypeNode;
    readonly value: TypeNode;
    readonly size: SizeStrategy;
    readonly idlMap: 'hashMap' | 'bTreeMap';
};
export declare function mapTypeNode(key: TypeNode, value: TypeNode, options?: {
    readonly size?: SizeStrategy;
    readonly idlMap?: MapTypeNode['idlMap'];
}): MapTypeNode;
export declare function mapTypeNodeFromIdl(idl: IdlTypeMap): MapTypeNode;
export declare function isMapTypeNode(node: Node | null): node is MapTypeNode;
export declare function assertMapTypeNode(node: Node | null): asserts node is MapTypeNode;
